config() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  # If there's no config file by that name, mv it over:
  if [ ! -r $OLD ]; then
    mv $NEW $OLD
  elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
    # toss the redundant copy
    rm $NEW
  fi
  # Otherwise, we leave the .new copy for the admin to consider...
}

preserve_perms() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  if [ -e $OLD ]; then
    cp -a $OLD ${NEW}.incoming
    cat $NEW > ${NEW}.incoming
    mv ${NEW}.incoming $NEW
  fi
  config $NEW
}

preserve_perms etc/rc.d/rc.mailman.new
config opt/mailman/Mailman/mm_cfg.py.new

# Ensure the private archive doesn't have o+w
chmod o-x  opt/mailman/var/mailman/archives/private
( cd usr/doc ; rm -rf mailman-2.1.39 )
( cd usr/doc ; ln -sf /opt/mailman/doc/mailman-2.1.39 mailman-2.1.39 )
